﻿// Global Variables //
/***********************************/
var carousel = null;
var carouselElem = null;
var carouselOptions = null;
var js_No_Image_Data_URI = null;
var js_Sync_Interval_Time = 24;     //24 hours
var js_InAppBrowserRef = null;      // Global InAppBrowser reference
/***********************************/

// Global Application View Model //
/***********************************/
var MyApp_VM = {
    LIST_SOURCE                  : ko.mapping.fromJS([]),
    FEATURED_PRODUCTS            : ko.mapping.fromJS([]),
    SEARCHED_PRODUCTS            : ko.mapping.fromJS([]),    
    CATEGORIES                   : ko.mapping.fromJS([]),
    OCCASIONS                    : ko.mapping.fromJS([]),
    LIST_PRICE_SORTING           : ko.mapping.fromJS([{ 'CODE': '1', 'DESCRIPTION': 'Prices low to high' }, { 'CODE': '2', 'DESCRIPTION': 'Prices high to low'}]),
    PRICE_BRACKETS               : ko.mapping.fromJS([]),
    PRODUCT_OPTIONSGROUPS        : ko.mapping.fromJS([]),
    PRODUCT_OPTIONSPRODEX        : ko.mapping.fromJS([]),       // Excluded options
    PRODUCT_OPTIONS              : ko.mapping.fromJS([]),       // All available Product options
    SELECTED_PRODUCT_OPTIONS     : ko.mapping.fromJS([]),
    SELECTED_SOURCE              : ko.mapping.fromJS(null),    
    SELECTED_PRODUCT             : ko.mapping.fromJS(null),
    PRODUCT_ADDONS               : ko.mapping.fromJS([]),      
    SELECTED_CATEGORY            : ko.mapping.fromJS(null),
    SELECTED_OCCASION            : ko.mapping.fromJS(null),    
    SELECTED_PRICE_BRACKET       : ko.mapping.fromJS(null),
    SELECTED_PRICE_SORTING       : ko.mapping.fromJS(null),
    SELECTED_OPTION              : ko.mapping.fromJS(null),
    SELECTED_PRODUCT_ADDONS_IDS  : ko.mapping.fromJS([]),
    SELECTED_ORDER               : ko.mapping.fromJS({'CARTHEAD_ID': -1, 'TOTAL': -1}),
    DESCENDING_FLAG              : ko.observable(1),
    ASCENDING_FLAG               : ko.observable(-1),
    FILTER                       : ko.observable(""),
    CARTHEAD                     : ko.mapping.fromJS(null),
    CARTROWS                     : ko.mapping.fromJS([]),
    LOGIN_PURPOSE                : ko.observable(""),
    STORE_ADMIN                  : ko.mapping.fromJS([]),
    LOCATIONS                    : ko.mapping.fromJS([]),
    SHIPRATES                    : ko.mapping.fromJS([]),
    SHIPMETHOD                   : ko.mapping.fromJS([]),
    DELIVERY_DATES               : ko.mapping.fromJS([]),
    QUANTITIES                   : ko.mapping.fromJS([1,2,3,4,5,6,7,8,9,10,11,12]),
    DISCCODE                     : ko.observable(""),
    IS_LOGGEDIN                  : ko.observable(false),
    IS_CONNECTED                 : ko.observable(true),
    IS_HIGHSPEED                 : ko.observable(false),
    CP_STATUS                    : ko.observable("unknown"),
    PAYMENT_NO2CO                : ko.observable(0),            // Set on Product level but affects cart final Payment Type
    PAYMENT_CASH                 : ko.observable(0),            // Set on Product level but affects cart final Payment Type
    CART_PAYMENT_TYPE            : ko.observable(0),            // Set according to PAYMENT_NO2CO and PAYMENT_CASH
    PAYPAL                       : ko.observable(-1),
    MAILIN                       : ko.observable(-1),
    TWOCHECKOUT                  : ko.observable(-1),
    FEATUREDPROD_DIV_COUNT       : ko.observable(0),
    PLATFORM                     : ko.observable("")
};
/***********************************/

// START SUBSCRIBE //
/*************************************************************************************************************************/
/***********************************/
MyApp_VM.SELECTED_SOURCE.subscribe(function (newVal) {

    if (newVal == null) { return; }

    var Get_My_Cart_Info_Success = function () {
        // Clear existing Cart
        // ------------------------            
        if (MyApp_VM.CARTHEAD() != null && parseInt(MyApp_VM.CARTHEAD().SOURCE_ID) != parseInt(newVal.SURROGATE_ID())) {            
            // LOGOUT
            // ------------------
            ko.mapping.fromJS(Customer, _Customer);
            MyApp_VM.IS_LOGGEDIN(false);
            // ------------------

            // Reset some properties
            // ---------------
            _Customer.PAYMENTTYPE("2CheckOut");
            _Customer.DELIVERYDATE(null);
            // ---------------

            // Clear Cart
            // ------------------
            var Clear_Cart_Success = function () {
                // Initialize Cart
                // ------------------------
                MyApp_VM.Initialize_Cart();
                // ------------------------    
            };

            MyApp_VM.Clear_Cart(Clear_Cart_Success);
            // ------------------
        }
        else {            
            // Initialize Cart
            // ------------------------
            MyApp_VM.Initialize_Cart();
            // ------------------------
        }
        // ------------------------
    };

    // Get Cart Info
    // ------------------------
    Get_My_Cart_Info(Get_My_Cart_Info_Success);
    // ------------------------       

    // ------------------------
    Get_Synced_Data(newVal);
    // ------------------------    
});
/***********************************/
//#################################//
function Get_Synced_Data(newVal) {
   
    // Carousel reinit
    // ---------------------
    $("#carousel_featured_products").hide();
    $("#div_Loading").show();        
    // ------------------    
    MyApp_VM.FEATUREDPROD_DIV_COUNT(0);
    $("#carousel_featured_products").html('');
    carousel = carouselElem.data('owlCarousel');
    carousel.reinit(carouselOptions);
    // ------------------

    // Get_Local_Storeadmin_By_SOURCE_ID
    // ------------------
    MyApp_VM.STORE_ADMIN([]);

    var Params_Get_Local_Storeadmin_By_SOURCE_ID = new Object();
    Params_Get_Local_Storeadmin_By_SOURCE_ID.SOURCE_ID = parseInt(newVal.SURROGATE_ID());

    var Get_Local_Storeadmin_By_SOURCE_ID_Success = function (result) {
        ko.mapping.fromJS(result, MyApp_VM.STORE_ADMIN);
    };

    Get_Local_Storeadmin_By_SOURCE_ID(Params_Get_Local_Storeadmin_By_SOURCE_ID, Get_Local_Storeadmin_By_SOURCE_ID_Success, null, null);
    // ------------------

    // Get_Local_Featured_Products
    // ------------------    
    MyApp_VM.FEATURED_PRODUCTS([]);

    var Params_Get_Local_Featured_Products = new Object();
    Params_Get_Local_Featured_Products.SOURCE_CODE = newVal.CODE();
    //Params_Get_Local_Featured_Products.ADDON = "N";
    //Params_Get_Local_Featured_Products.CATEGORYFEATURED = "Y";

    Get_Local_Featured_Products
	(
		Params_Get_Local_Featured_Products,
		null,
		null,
		MyApp_VM.FEATURED_PRODUCTS,
        Carousel_Handler
	);    
    // ------------------

    // Categories && Occasions
    // ------------------    
    MyApp_VM.CATEGORIES([]);
    MyApp_VM.OCCASIONS([]);
    
    var Params_Get_Local_Categories = new Object();
    Params_Get_Local_Categories.SOURCE_ID = parseInt(newVal.SURROGATE_ID());
    //Params_Get_Local_Categories.ADDON = 'N';
    ////Params_Get_Local_Categories.CATEGORYPROM = 'Y';
    //Params_Get_Local_Categories.CATEGORYFEATURED = 'Y';

    var Categories = [];
    var Occasions = [];

    var Get_Local_Categories_Success = function (result) {
        if (result != null) {
            for (var i = 0; i < result.length; i++) {
                if (result[i].ADDON != "N") {
                    continue;
                }
                else {
                    if (result[i].CATEGORYFEATURED == "Y" && result[i].IDPARENTCATEGORY != 0) {
                        Categories.push(result[i]);
                    }
                    else if (result[i].CATEGORYFEATURED == "N" && result[i].IDPARENTCATEGORY != 0) {
                        Occasions.push(result[i]);
                    }
                }

                /*if (result[i].IDPARENTCATEGORY != 0) {
                Categories.push(result[i]);                    
                }*/
            }
        }

        MyApp_VM.CATEGORIES(ko.mapping.fromJS(Categories).sort(function (left, right) {
            var a = left.CATEGORYDESC().toLowerCase();
            var b = right.CATEGORYDESC().toLowerCase();
            return a == b ? 0 : (a < b ? -1 : 1)
        }).sort(function (left, right) {
            var a = left.SORTORDER();
            var b = right.SORTORDER();
            return a - b
        }));

        MyApp_VM.OCCASIONS(ko.mapping.fromJS(Occasions).sort(function (left, right) {
            var a = left.CATEGORYDESC().toLowerCase();
            var b = right.CATEGORYDESC().toLowerCase();
            return a == b ? 0 : (a < b ? -1 : 1)
        }).sort(function (left, right) {
            var a = left.SORTORDER();
            var b = right.SORTORDER();
            return a - b
        }));
    }

    Get_Local_Categories_By_SOURCE_ID
    (
        Params_Get_Local_Categories,
        Get_Local_Categories_Success,
        null
    );    
    // ------------------

    // Occasions
    // ------------------    
    /*MyApp_VM.OCCASIONS([]);
    var Params_Get_Local_Occasions = new Object();
    Params_Get_Local_Occasions.SOURCE_ID = parseInt(newVal.SURROGATE_ID());
    Params_Get_Local_Occasions.ADDON = 'N';
    Params_Get_Local_Occasions.CATEGORYFEATURED = 'N';

    var Occasions = [];

    var Get_Local_Occasions_Success = function (result) {
        if (result != null) {
            for (var i = 0; i < result.length; i++) {
                if (result[i].IDPARENTCATEGORY != 0) {
                    Occasions.push(result[i]);                    
                }
            }
        }
        MyApp_VM.OCCASIONS(ko.mapping.fromJS(Occasions).sort(function (left, right) {
            var a = left.CATEGORYDESC().toLowerCase();
            var b = right.CATEGORYDESC().toLowerCase();
            return a == b ? 0 : (a < b ? -1 : 1)
        }).sort(function (left, right) {
            var a = left.SORTORDER();
            var b = right.SORTORDER();
            return a - b
        }));
    }

    Get_Local_Categories_By_SOURCE_ID_ADDON_CATEGORYFEATURED
    (
        Params_Get_Local_Occasions,
        Get_Local_Occasions_Success,
        null
    );*/
    // ------------------

    // Empy Text Filter wich will Empty search results
    // ------------------
    MyApp_VM.FILTER('');
    // ------------------

    // Price Brackets
    // ------------------
    try {
        var suffix = "";
        switch (newVal.CODE()) {
            case "FTL":
                suffix = "_FTL";
                break;
            case "FD":
                suffix = "_FD";
                break;
        }
        var Params_Get_Setup_Price_Brackets = new Object();
        //Params_Get_Setup_Price_Brackets.OWNER_ID = 1;
        Params_Get_Setup_Price_Brackets.TBL_NAME = '_PRICE_BRACKET' + suffix;

        var Get_Setup_Price_Brackets_Success = function (result) {            
            ko.mapping.fromJS(result, MyApp_VM.PRICE_BRACKETS);

            if (suffix == "") {
                ko.utils.arrayForEach(MyApp_VM.PRICE_BRACKETS(), function (Item_PriceBracket) {
                    var x = Item_PriceBracket.CODE_VALUE_EN().toString();
                    var x1 = x.replace(/\$/g, MyApp_VM.CURRENCY_SIGN());
                    Item_PriceBracket.CODE_VALUE_EN(x1);
                });
            }
        };

        Get_Local_Setup_By_TBL_NAME
        (
          Params_Get_Setup_Price_Brackets,
          Get_Setup_Price_Brackets_Success,
          null
        );
    }
    catch (e) {
        Notify("XX:Get_Local_Setup_By_OWNER_ID_TBL_NAME" + e.message);
    }
    // ------------------

    // Get Locations
    // ------------------
    MyApp_VM.LOCATIONS([]);

    var Params_Get_Local_Locations_By_SOURCE_ID = new Object();
    Params_Get_Local_Locations_By_SOURCE_ID.SOURCE_ID = parseInt(newVal.SURROGATE_ID());
    var Get_Local_Locations_By_SOURCE_ID_Success = function (result) {
        ko.mapping.fromJS(result, MyApp_VM.LOCATIONS);

        // Reselect DropDowns
        // --------------------------------------
        if (obj_Customer != null) {
            _Customer.LOCCOUNTRY(obj_Customer.LOCCOUNTRY);
            _Customer.SHIPPINGLOCSTATE(obj_Customer.SHIPPINGLOCSTATE);
            // -------------------
            try {
                $("#Ddl_Country_billing").selectmenu('refresh');
                $("#Ddl_Region_shipping").selectmenu('refresh');
            }
            catch (e) { }
            // -------------------
        }
        // --------------------------------------
    };
    Get_Local_Locations_By_SOURCE_ID(Params_Get_Local_Locations_By_SOURCE_ID, Get_Local_Locations_By_SOURCE_ID_Success);
    // ------------------

    // Get ShipRates
    // ------------------
    MyApp_VM.SHIPRATES([]);

    var Params_Get_Local_Shiprates_By_SOURCE_ID = new Object();
    Params_Get_Local_Shiprates_By_SOURCE_ID.SOURCE_ID = parseInt(newVal.SURROGATE_ID());
    var Get_Local_Shiprates_By_SOURCE_ID_Success = function (result) {
        ko.mapping.fromJS(result, MyApp_VM.SHIPRATES);
    };
    Get_Local_Shiprates_By_SOURCE_ID(Params_Get_Local_Shiprates_By_SOURCE_ID, Get_Local_Shiprates_By_SOURCE_ID_Success);
    // ------------------

    // Get ShipMethod
    // ------------------
    MyApp_VM.SHIPMETHOD([]);

    var Params_Get_Local_Shipmethod_By_SOURCE_ID = new Object();
    Params_Get_Local_Shipmethod_By_SOURCE_ID.SOURCE_ID = parseInt(newVal.SURROGATE_ID());
    var Get_Local_Shipmethod_By_SOURCE_ID_Success = function (result) {
        ko.mapping.fromJS(result, MyApp_VM.SHIPMETHOD);
    };
    Get_Local_Shipmethod_By_SOURCE_ID(Params_Get_Local_Shipmethod_By_SOURCE_ID, Get_Local_Shipmethod_By_SOURCE_ID_Success);
    // ------------------    
}
//#################################//

/***********************************/
MyApp_VM.SELECTED_CATEGORY.subscribe(function (newVal) {
    if (newVal != null) {
        MyApp_VM.FILTER("");        
        MyApp_VM.SELECTED_OCCASION(null);
        MyApp_VM.SELECTED_PRICE_BRACKET(null);
        MyApp_VM.Search_Products();
    }
});
/***********************************/

/***********************************/
MyApp_VM.SELECTED_OCCASION.subscribe(function (newVal) {
    if (newVal != null) {
        MyApp_VM.FILTER("");        
        MyApp_VM.SELECTED_CATEGORY(null);
        MyApp_VM.SELECTED_PRICE_BRACKET(null);
        MyApp_VM.Search_Products();
    }
});
/***********************************/

/***********************************/
MyApp_VM.SELECTED_PRICE_BRACKET.subscribe(function (newVal) {
    if (newVal != null) {
        MyApp_VM.FILTER("");
        MyApp_VM.SELECTED_CATEGORY(null);
        MyApp_VM.SELECTED_OCCASION(null);
        MyApp_VM.Search_Products();        
    }
});
/***********************************/

/***********************************/
MyApp_VM.FILTER.subscribe(function (newVal) {    
    if (newVal != null && newVal != '') {
        MyApp_VM.SELECTED_CATEGORY(null);
        MyApp_VM.SELECTED_OCCASION(null);
        MyApp_VM.SELECTED_PRICE_BRACKET(null);        
        MyApp_VM.Search_Products();
    }
});
/***********************************/

/***********************************/
MyApp_VM.SELECTED_PRICE_SORTING.subscribe(function (newVal) {
    if (newVal != null) {
        if (newVal.CODE() == '1') { // Assending            
            MyApp_VM.ASCENDING_FLAG(-1);
            MyApp_VM.DESCENDING_FLAG(1);
            //.sort(function (l, r) { return l.PRICE() > r.PRICE() ?  DESCENDING_FLAG() : ASCENDING_FLAG() })
        }
        else {
            MyApp_VM.ASCENDING_FLAG(1);
            MyApp_VM.DESCENDING_FLAG(-1);
        }
    }
    else {
        MyApp_VM.ASCENDING_FLAG(-1);
        MyApp_VM.DESCENDING_FLAG(1);
    }
});
/***********************************/

/***********************************/
MyApp_VM.SELECTED_PRODUCT.subscribe(function (newVal) {
    if (newVal != null) {
        var func = function () {
            // ---------------------
            jq_ShowMobileLoader();
            jq_BlockUI();
            // ---------------------
            var Get_Local_Product_Excluded_Options_Success = function () {
                //alert("1- Product_Excluded_Options");
                // #################################
                var Get_Local_Product_OptionsGroups_Success = function () {
                    //alert("2- Product_OptionsGroups");
                    // $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
                    var Get_Get_Local_Product_Addons_Success = function () {
                        //alert("3- Product_Addons");
                        // ---------------------
                        jq_HideMobileLoader();
                        jq_UnBlockUI();
                        // ---------------------
                    }
                    MyApp_VM.Get_Get_Local_Product_Addons(Get_Get_Local_Product_Addons_Success);
                    // ---------------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------------
                    // $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
                };
                MyApp_VM.Get_Local_Product_OptionsGroups(Get_Local_Product_OptionsGroups_Success);
                // #################################
            };
            MyApp_VM.Get_Local_Product_Excluded_Options(Get_Local_Product_Excluded_Options_Success);
        }
        setTimeout(func, 500);
        /*var func = function () {
        MyApp_VM.Get_Local_Product_OptionsGroups();
        }
        setTimeout(func, 500);*/

        //MyApp_VM.Get_Local_Product_Options();
        //MyApp_VM.Get_Get_Local_Product_Addons();
    }
});
/***********************************/
/*************************************************************************************************************************/
// END SUBSCRIBE //

// START FUNCTION //
/*************************************************************************************************************************/
/***********************************/
MyApp_VM.Search_Products = function () {    
    // ------------------
    ko.mapping.fromJS([], MyApp_VM.SEARCHED_PRODUCTS);
    // ------------------

    // ------------------
    var Params_Get_Local_Products_By_Criteria = new Object();
    Params_Get_Local_Products_By_Criteria.SOURCE_CODE = '';
    Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST = [];
    Params_Get_Local_Products_By_Criteria.PRICE_LOWER_BOUND = 0;
    Params_Get_Local_Products_By_Criteria.PRICE_UPPER_BOUND = 100000;
    Params_Get_Local_Products_By_Criteria.FILTER = MyApp_VM.FILTER();
    // ------------------

    // ------------------    
    if (MyApp_VM.SELECTED_SOURCE() != null) {
        Params_Get_Local_Products_By_Criteria.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    }
    // ------------------

    // ------------------
    Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST = [];
    if (MyApp_VM.SELECTED_CATEGORY() != null) {
        Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST.push(MyApp_VM.SELECTED_CATEGORY().IDCATEGORY());
    }
    if (MyApp_VM.SELECTED_OCCASION() != null) {
        Params_Get_Local_Products_By_Criteria.IDCATEGORY_LIST.push(MyApp_VM.SELECTED_OCCASION().IDCATEGORY());
    }
    // ------------------

    // ------------------
    if (MyApp_VM.SELECTED_PRICE_BRACKET() != null) {
        Params_Get_Local_Products_By_Criteria.PRICE_LOWER_BOUND = MyApp_VM.SELECTED_PRICE_BRACKET().CODE_VALUE_FR();
        Params_Get_Local_Products_By_Criteria.PRICE_UPPER_BOUND = MyApp_VM.SELECTED_PRICE_BRACKET().CODE_VALUE_AR();
    }
    // ------------------


    // ------------------	
    //ko.mapping.fromJS([], MyApp_VM.SEARCHED_PRODUCTS);
    Get_Local_Products_By_Criteria
								(
									Params_Get_Local_Products_By_Criteria,
									null,
									null,
									MyApp_VM.SEARCHED_PRODUCTS
								);
    // ------------------
}
/***********************************/

/***********************************/
MyApp_VM.SHOW_PRODUCT_DETAILS = function (product) {
    // ----------------------------
    MyApp_VM.PRODUCT_OPTIONSPRODEX([]);
    MyApp_VM.PRODUCT_OPTIONSGROUPS([]);    
    MyApp_VM.PRODUCT_OPTIONS([]);

    //MyApp_VM.SELECTED_PRODUCT_OPTIONS([]);
    MyApp_VM.PRODUCT_ADDONS([]);
    MyApp_VM.SELECTED_PRODUCT_ADDONS_IDS([]);
    // ----------------------------
    MyApp_VM.SELECTED_PRODUCT(product);

    jq_NavigateToPage("pg_product");
}
/***********************************/

/***********************************/
MyApp_VM.Get_Product_Quantities = function (STOCK) {    
    var arr_Quantity = [];
    var max = STOCK;

    if (STOCK > 10) {
        max = 10;
    }

    for (var i = 1; i <= max; i++) {
        arr_Quantity.push(i);
    }

    return arr_Quantity; //ko.mapping.fromJS(arr_Quantity);
}
/***********************************/

/***********************************/
MyApp_VM.Get_Mapped_IDOPTIONs = function () {    
    var mapped = [];    
    mapped = ko.utils.arrayMap(MyApp_VM.PRODUCT_OPTIONSPRODEX(), function (item) {            
            return item.IDOPTION();
    });
    
    return mapped;
}
/***********************************/

/***********************************/
MyApp_VM.Get_Local_Product_OptionsGroups = function (SuccessHandler) {

    var Params_Get_Local_Product_OptionsGroups = new Object();
    Params_Get_Local_Product_OptionsGroups.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Get_Local_Product_OptionsGroups.IDPRODUCT = MyApp_VM.SELECTED_PRODUCT().IDPRODUCT();

    var Get_Local_Product_GroupOptions_Success = function () {
        if (SuccessHandler) {
            SuccessHandler();
        }
    };
    Get_Local_Product_GroupOptions
    (
        Params_Get_Local_Product_OptionsGroups,
        Get_Local_Product_GroupOptions_Success,
        null,
        MyApp_VM.Get_Mapped_IDOPTIONs(),
        MyApp_VM.PRODUCT_OPTIONSGROUPS,
        MyApp_VM.PRODUCT_OPTIONS
    );
};
/***********************************/

/***********************************/
MyApp_VM.Get_Local_Product_Excluded_Options = function (SuccessHandler) {

    var Params_Get_Local_Product_Excluded_Options = new Object();
    Params_Get_Local_Product_Excluded_Options.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Get_Local_Product_Excluded_Options.IDPRODUCT = MyApp_VM.SELECTED_PRODUCT().IDPRODUCT();

    var Get_Local_Product_Excluded_Options_Success = function () {
        if (SuccessHandler) {
            SuccessHandler();
        }
    };

    Get_Local_Product_Excluded_Options
    (
        Params_Get_Local_Product_Excluded_Options,
        Get_Local_Product_Excluded_Options_Success,
        null,
        MyApp_VM.PRODUCT_OPTIONSPRODEX
    );
};
/***********************************/

// EXCLUDED
/***********************************/
MyApp_VM.Get_Local_Product_Options = function () {

    var Params_Get_Local_Group_Options = new Object();
    Params_Get_Local_Group_Options.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Get_Local_Group_Options.IDOPTIONGROUP = IDOPTIONGROUP;
    /*var Params_Get_Local_Product_Options = new Object();
    Params_Get_Local_Product_Options.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Get_Local_Product_Options.IDPRODUCT = MyApp_VM.SELECTED_PRODUCT().IDPRODUCT();*/

    Get_Local_Product_Options
    (
        Params_Get_Local_Product_Options,
        null,
        null,
        MyApp_VM.PRODUCT_OPTIONS
    );
};
/***********************************/

/***********************************/
MyApp_VM.Get_Get_Local_Product_Addons = function (SuccessHandler) {

    var Params_Get_Local_Product_Addons = new Object();
    Params_Get_Local_Product_Addons.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Get_Local_Product_Addons.IDPRODUCT = MyApp_VM.SELECTED_PRODUCT().IDPRODUCT();
   
    var Get_Local_Product_Addons_Success = function () {
        if (SuccessHandler) {
            SuccessHandler();
        }
    };
    Get_Local_Product_Addons
    (
      Params_Get_Local_Product_Addons,
      Get_Local_Product_Addons_Success,
      null,
      MyApp_VM.PRODUCT_ADDONS
    );
}
/***********************************/

/***********************************/
MyApp_VM.Clear_Cart = function (SuccessHandler) {    
    // Delete CartHead //
    // $$$$$$$$$$$$$$$$$$
    var Params_Delete_Local_Carthead_By_OWNER_ID = new Object();
    Params_Delete_Local_Carthead_By_OWNER_ID.OWNER_ID = 1;

    var Delete_Local_Carthead_By_OWNER_ID_Success = function (result) {
        // Reset CartHead //        
        ko.mapping.fromJS(null, MyApp_VM.CARTHEAD);
        // -----------------

        // Delete CartRows //
        // ##################
        var Params_Delete_Local_Cartrows_By_OWNER_ID = new Object();
        Params_Delete_Local_Cartrows_By_OWNER_ID.OWNER_ID = 1;

        var Delete_Local_Cartrows_By_OWNER_ID_Success = function () {
            // Reset CartRows //        
            MyApp_VM.CARTROWS([]);
            // -----------------

            // Delete CartRowsOptions //
            // @@@@@@@@@@@@@@@@@@@@@@@@@
            var Params_Delete_Local_Cartrowsoptions_By_OWNER_ID = new Object();
            Params_Delete_Local_Cartrowsoptions_By_OWNER_ID.OWNER_ID = 1;

            var Delete_Local_Cartrowsoptions_By_OWNER_ID_Success = function () {
                // ------------------
                if (SuccessHandler) {
                    SuccessHandler();
                }
                // ------------------
            };
            Delete_Local_Cartrowsoptions_By_OWNER_ID(Params_Delete_Local_Cartrowsoptions_By_OWNER_ID, Delete_Local_Cartrowsoptions_By_OWNER_ID_Success);
            // @@@@@@@@@@@@@@@@@@@@@@@@@
        };
        Delete_Local_Cartrows_By_OWNER_ID(Params_Delete_Local_Cartrows_By_OWNER_ID, Delete_Local_Cartrows_By_OWNER_ID_Success);
        // ##################        
    };
    Delete_Local_Carthead_By_OWNER_ID(Params_Delete_Local_Carthead_By_OWNER_ID, Delete_Local_Carthead_By_OWNER_ID_Success);
    // $$$$$$$$$$$$$$$$$$
}
/***********************************/

/***********************************/
MyApp_VM.Initialize_Cart = function (SuccessHandler) {
    // --------------------
    Params_Initialize_Card_Head.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    var Initialize_Card_Head_Success = function (result) {
        // ------------
        ko.mapping.fromJS(result, MyApp_VM.CARTHEAD);
        // ------------  

        // Save Last used SOURCE_ID in DEVICE_DATA table
        // ----------------        
        Edit_Device_Data("SOURCE_ID", result.SOURCE_ID);
        // ----------------   
        
        // ------------------
        if (SuccessHandler) {
            SuccessHandler();
        }
        // ------------------
    }

    Initialize_Card_Head
    (
        Params_Initialize_Card_Head,
        Initialize_Card_Head_Success,
        null
    );
    // --------------------
};
/***********************************/

/***********************************/
MyApp_VM.Add_To_Cart = function () {
    //alert(ko.mapping.toJSON(MyApp_VM.PRODUCT_OPTIONSGROUPS));
    if ($("#Frm_ProdOptions").valid()) {
        // ---------------------
        jq_ShowMobileLoader();
        jq_BlockUI();
        // ---------------------

        // ------------
        var Params_Add_To_Cart = new Object();
        Params_Add_To_Cart.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
        Params_Add_To_Cart.IDPRODUCT_LIST = [];
        if (MyApp_VM.SELECTED_PRODUCT() != null) {
            Params_Add_To_Cart.IDPRODUCT_LIST.push(parseInt(MyApp_VM.SELECTED_PRODUCT().IDPRODUCT()));
        }
        if (MyApp_VM.SELECTED_PRODUCT_ADDONS_IDS() != null) {
            for (var i = 0; i < MyApp_VM.SELECTED_PRODUCT_ADDONS_IDS().length; i++) {
                Params_Add_To_Cart.IDPRODUCT_LIST.push(parseInt(MyApp_VM.SELECTED_PRODUCT_ADDONS_IDS()[i]));
            }
        }

        var Add_To_Cart_Success = function () {
            // Calculate_Cart
            // -------------
            var Params_Calculate_Cart = new Object();
            Params_Calculate_Cart.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
            var Calculate_Cart_Success = function (result) {
                // ---------------------
                jq_HideMobileLoader();
                jq_UnBlockUI();
                // ---------------------
                // ---------------------
                jq_NavigateToPage("pg_cart");
                // ---------------------
            };
            Calculate_Cart
            (
                Params_Calculate_Cart,
                Calculate_Cart_Success,
                null
            );
            // -------------                                      
        };

        Add_To_Cart
        (
            Params_Add_To_Cart,
            Add_To_Cart_Success,
            null,
            null
        );
        // ------------
    }
    else {
        // Focus invalid input
        // -------------------
        Validator_ProdOptions.focusInvalid();
        // -------------------
    }
};
/***********************************/

/***********************************/
MyApp_VM.Remove_Product_From_Cart = function (product) {
    // ----------------------
    var Params_Remove_From_Cart = new Object();
    Params_Remove_From_Cart.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Remove_From_Cart.CARTROWS_ID = parseInt(product.CARTROWS_ID());
    //Params_Remove_From_Cart.IDPRODUCT = parseInt(product.IDPRODUCT());

    var Remove_From_Cart_Success = function (input) {
        //MyApp_VM.CARTROWS.remove(input);
        Get_My_Cart_Info();
    }
   
    Remove_From_Cart
    (
        Params_Remove_From_Cart,
        Remove_From_Cart_Success,
        null,
        product
    );
    // ----------------------
}
/***********************************/

/***********************************/
MyApp_VM.Update_Product_Cart_Quantity = function (product) {    
    var Params_Update_Cart = new Object();
    Params_Update_Cart.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();
    Params_Update_Cart.IDPRODUCT = product.IDPRODUCT();
    Params_Update_Cart.QUANTITY = product.QUANTITY();

    Update_Cart_Success = function (result) {
        Get_My_Cart_Info();
    };

    Update_Cart
    (
        Params_Update_Cart,
        Update_Cart_Success,
        null,
        null
    );
}
/***********************************/

// Get_StoreAdmin_ConfingItem //
/***********************************/
MyApp_VM.Get_StoreAdmin_ConfingItem = function (CONFIG_VAR) {
    var StoreAdmin = new Object();
    StoreAdmin.ADMINTYPE = '';
    StoreAdmin.CONFIGVAR = '';
    StoreAdmin.CONFIGVAL = '';
    StoreAdmin.CONFIGVALLONG = '';
    StoreAdmin.SOURCE_ID = -1;
    StoreAdmin.ENTRY_USER_ID = -1;
    StoreAdmin.ENTRY_DATE = '2014/03/17';
    StoreAdmin.OWNER_ID = -1;
    StoreAdmin.IDCONFIG = -1;
    StoreAdmin.STOREADMIN_ID = -1;

    var _StoreAdmin = ko.mapping.fromJS(StoreAdmin);

    var match = ko.utils.arrayFirst(MyApp_VM.STORE_ADMIN(), function (StoreAdmin_Item) {
        return StoreAdmin_Item.CONFIGVAR() == CONFIG_VAR;
    });

    if (match) {
        ko.mapping.fromJS(ko.mapping.toJS(match), _StoreAdmin);
    }

    return _StoreAdmin;
}
/***********************************/

// Get_PaymentMsg
/***********************************/
MyApp_VM.Get_PaymentMsg = function (PAYMENTTYPE) {
    var paymentMsg;

    switch (PAYMENTTYPE.toLowerCase()) {
        case "mailin":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgMailIn').CONFIGVAL();
            break;
        case "callin":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgCallIn').CONFIGVAL();
            break;
        case "faxin":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgFaxIn').CONFIGVAL();
            break;
        case "cod":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgCOD').CONFIGVAL();
            break;
        case "creditcard":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgCreditCard').CONFIGVAL();
            break;
        case "paypal":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgPayPal').CONFIGVAL();
            break;
        case "2checkout":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgTwoCheckOut').CONFIGVAL();
            break;
        case "authorizenet":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgAuthNet').CONFIGVAL();
            break;
        case "custom":
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgCustom').CONFIGVAL();
            break;
        default:
            paymentMsg = MyApp_VM.Get_StoreAdmin_ConfingItem('payMsgOther').CONFIGVAL();
            break;
    }
    return paymentMsg;
}
/***********************************/

// GetCountryDesc //
/***********************************/
MyApp_VM.GetCountryDesc = function (LOCCOUNTRY) {
    if ($.trim(LOCCOUNTRY) != '') {
        var match = ko.utils.arrayFirst(MyApp_VM.LOCATIONS(), function (Location_Item) {
            return Location_Item.LOCCOUNTRY() == LOCCOUNTRY;
        });

        if (match) {
            return match.LOCNAME();
        }
        else {
            return '';
        }
    }
    else {
        return '';
    }
}
/***********************************/

// GetStateDesc //
/***********************************/
MyApp_VM.GetStateDesc = function (LOCSTATE) {
    var js_Dest = MyApp_VM.Get_StoreAdmin_ConfingItem('fDestCode').CONFIGVAL();
    if ($.trim(LOCSTATE) != '') {
        var match = ko.utils.arrayFirst(MyApp_VM.LOCATIONS(), function (Location_Item) {
            return Location_Item.LOCSTATE() == LOCSTATE;
        });

        if (match) {
            return match.LOCNAME(); //.toString().replace(' (' + js_Dest + ')', '');
        }
        else {
            return '';
        }
    }
    else {
        return '';
    }
}
/***********************************/

// SetSelectedOrder //
/***********************************/
MyApp_VM.SetSelectedOrder = function (ORDER) {
    ko.mapping.fromJS(ko.mapping.toJS(ORDER), MyApp_VM.SELECTED_ORDER);
    // ---------------------
    jq_NavigateToPage("pg_custorder");
    // ---------------------  
}
/***********************************/

// GetOrderStatusDesc //
/***********************************/
MyApp_VM.GetOrderStatusDesc = function (ORDERSTATUS) {
    var js_orderStatusDesc;

    switch (ORDERSTATUS) {
        case "U":
            js_orderStatusDesc = 'Unfinalized';
            break;
        case "S":
            js_orderStatusDesc = 'Saved';
            break;
        case "0":
            js_orderStatusDesc = 'Pending';
            break;
        case "1":
            js_orderStatusDesc = 'Paid';
            break;
        case "2":
            js_orderStatusDesc = 'Shipped';
            break;
        case "7":
            js_orderStatusDesc = 'Complete';
            break;
        case "9":
            js_orderStatusDesc = 'Cancelled';
            break;
        default:
            js_orderStatusDesc = 'Unknown';
            break;
    }

    return js_orderStatusDesc;
}
/***********************************/

/***********************************/
var Carousel_Handler = function (entry) {
    try {
        var js_Content = '<div class="featured_product" data-prodid="' + entry.IDPRODUCT() + '"><img src="' + entry.DATA_URI() + '" alt="" /></div>';
        carousel = carouselElem.data('owlCarousel');
        carousel.addItem(js_Content);
        // ---------------------
        var featured_prod_count = MyApp_VM.FEATUREDPROD_DIV_COUNT() + 1;

        MyApp_VM.FEATUREDPROD_DIV_COUNT(featured_prod_count);

        if (MyApp_VM.FEATUREDPROD_DIV_COUNT() == MyApp_VM.FEATURED_PRODUCTS().length) {
            // ---------------------            
            $("#div_Loading").hide();
            $("#carousel_featured_products").show();            
            // ---------------------            
        }
    }
    catch (e) {
        Notify("Carousel_Handler: " + e.Message);
    }
}
/***********************************/

/***********************************/
var Get_My_Cart_Info = function (SuccessHandler) {
    try {
        // ---------------------
        var Params_Get_Cart = new Object();
        Params_Get_Cart.SOURCE_CODE = MyApp_VM.SELECTED_SOURCE().CODE();

        var Get_Cart_Success = function () {        
            // ------------------
            if (MyApp_VM.CARTHEAD() != null) {
                MyApp_VM.DISCCODE(MyApp_VM.CARTHEAD().DISCCODE);
            }
            // ------------------
            // ------------------
            if (SuccessHandler) {
                SuccessHandler();
            }
            // ------------------
        };
        
        Get_Cart
        (
            Params_Get_Cart,
            Get_Cart_Success,
            null,
            MyApp_VM.CARTHEAD,
            MyApp_VM.CARTROWS,
            MyApp_VM.Update_Product_Cart_Quantity
        )
        // ---------------------
    }
    catch (e) {
        Notify("Get_My_Cart_Info: " + e.Message);
    }
}
/*****************************************************/

/*****************************************************/
var Get_PayMsg = function () {
    try {
        var payMsg = "";
        var payMessageVar = "";

        if (MyApp_VM.CP_STATUS() != "") {
            var pCompany = MyApp_VM.Get_StoreAdmin_ConfingItem('pCompany').CONFIGVAL();
            var pEmailSales = MyApp_VM.Get_StoreAdmin_ConfingItem('pEmailSales').CONFIGVAL();

            if (MyApp_VM.CP_STATUS() == "success") {
                payMessageVar = 'paySuccessMsg';
            }
            else {
                payMessageVar = 'payErrorMsg';
            }

            payMsg = $.trim(MyApp_VM.Get_StoreAdmin_ConfingItem(payMessageVar).CONFIGVALLONG());
            payMsg = payMsg.replace(/#STORE#/gi, pCompany);
            payMsg = payMsg.replace(/#SALES#/gi, '<a target="_blank" href="mailto:' + pEmailSales + '">' + pEmailSales + '</a>');
        }

        return payMsg;
    }
    catch (e) {
        alert("Get_PayMsg: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var Construct_Order_Link = function () {
    try {
        //var pOrderPrefix = MyApp_VM.Get_StoreAdmin_ConfingItem('pOrderPrefix').CONFIGVAL();
        var total_span = '<span class="bold">Total: ' + MyApp_VM.CURRENCY_SIGN() + jq_formatMoney(_Params_CheckOut.My_Carthead.TOTAL()) + '</span> &raquo; ';
        var order_link = '<a href="javascript:void(0);" class="Lnk_CustOrder">Order ' + MyApp_VM.ORDER_PREFIX() + '-' + _Params_CheckOut.My_Carthead.IDORDER() + '</a>';
        var myacc_link = ''; //'<a href="javascript:void(0);" class="Lnk_MyAcc">Your Account</a>';

        return total_span + order_link + myacc_link;
    }
    catch (e) {
        alert("Construst_Order_Link: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var Authenticate = function (SuccessHandler, FailureHandler) {
    try {
        /* Call the Service. */
        /* ---------------- */
        _Params_Authenticate.SOURCE_ID(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID());

        _Params = ko.mapping.toJSON(_Params_Authenticate);

        _Service_Method = "Authenticate";

        CallService_Element(SuccessHandler, FailureHandler);
        /* ---------------- */
    }
    catch (e) {
        alert("Authenticate: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var Forgot_Password = function (SuccessHandler, FailureHandler) {
    try {
        /* Call the Service. */
        /* ---------------- */
        _Params_Forgot_Password.SOURCE_ID(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID());

        _Params = ko.mapping.toJSON(_Params_Forgot_Password);

        _Service_Method = "Forgot_Password";

        CallService_Element(SuccessHandler, FailureHandler);
        /* ---------------- */
    }
    catch (e) {
        alert("Forgot_Password: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var Send_ContactUs_Email = function (SuccessHandler, FailureHandler) {
    try {
        /* Call the Service. */
        /* ---------------- */
        _Params_Send_ContactUs_Email.SOURCE_ID(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID());

        _Params = ko.mapping.toJSON(_Params_Send_ContactUs_Email);

        _Service_Method = "Send_ContactUs_Email";

        CallService_Element(SuccessHandler, FailureHandler);
        /* ---------------- */
    }
    catch (e) {
        alert("Send_ContactUs_Email: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var Edit_Customer = function (SuccessHandler, FailureHandler) {
    try {
        /* Call the Service. */
        /* ---------------- */
        _Params = ko.mapping.toJSON(_Customer);

        _Service_Method = "Edit_Customer";

        CallService_Element(SuccessHandler, FailureHandler);
        /* ---------------- */
    }
    catch (e) {
        alert("Edit_Customer: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var CheckOut = function (SuccessHandler, FailureHandler) {
    try {
        /* Call the Service. */
        /* ---------------- */
        _Params = ko.mapping.toJSON(_Params_CheckOut);

        _Service_Method = "CheckOut";

        CallService_Element(SuccessHandler, FailureHandler);
        /* ---------------- */
    }
    catch (e) {
        alert("CheckOut: " + e.message);
    }
}
/*****************************************************/

/*****************************************************/
var Get_Carthead_By_Customer = function (SuccessHandler, FailureHandler) {
    try {
        /* Call the Service. */
        /* ---------------- */
        _Params = ko.mapping.toJSON(_Params_Get_Carthead_By_Customer);

        _Service_Method = "Get_Carthead_By_Customer";

        CallService_Element(SuccessHandler, FailureHandler);
        /* ---------------- */
    }
    catch (e) {
        alert("Get_Carthead_By_Customer: " + e.message);
    }
}
/*****************************************************/

// NETWORK DETECTION //
/*****************************************************/
function jq_networkDetection() {
    try {
        // as long as the connection type is not none,
        // the device should have Internet access
        if (navigator.network.connection.type != Connection.NONE) {
            MyApp_VM.IS_CONNECTED(true);
        }
        // determine if this connection is high speed or not
        switch (navigator.network.connection.type) {
            case Connection.UNKNOWN:
            case Connection.CELL_2G:
                MyApp_VM.IS_HIGHSPEED(false);
                break;
            default:
                MyApp_VM.IS_HIGHSPEED(true);
                break;
        }
    }
    catch (e) {
    }
}
function onOnline() {
    MyApp_VM.IS_CONNECTED(true);
}
function onOffline() {
    MyApp_VM.IS_CONNECTED(false);
}
/*****************************************************/

// CHECK INTERNET CONNECTION //
/*****************************************************/
function jq_ConnectionExist() {
    try {
        if (!MyApp_VM.IS_CONNECTED()) {
            jq_DisplayMessage("MSG_GeneralError", "", "To continue, please connect your device to the internet.");
        }

        return MyApp_VM.IS_CONNECTED();
    }
    catch (e) {
        alert('jq_ConnectionExist: ' + e.message);
    }
}
/*****************************************************/

// MOBILE CHECK
/*****************************************************/
window.mobilecheck = function () {
    var check = false;
    var isapp = document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1;

    if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) && isapp) {
        check = true;
    }
    //(function (a) { if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4))) check = true })(navigator.userAgent || navigator.vendor || window.opera);
    //|android|ipad|playbook|silk
    return check;
}
/*****************************************************/
/*************************************************************************************************************************/
// END FUNCTION //

// START COMPUTED //
/*************************************************************************************************************************/
/***********************************/
MyApp_VM.DELIVERY = ko.computed(function () {
    return MyApp_VM.Get_StoreAdmin_ConfingItem('pDelivery').CONFIGVAL();
});
/***********************************/

/***********************************/
MyApp_VM.CATALOG_ONLY = ko.computed(function () {
    return MyApp_VM.Get_StoreAdmin_ConfingItem('pCatalogOnly').CONFIGVAL();
});
/***********************************/

/***********************************/
MyApp_VM.CURRENCY_SIGN = ko.computed(function () {
    return MyApp_VM.Get_StoreAdmin_ConfingItem('pCurrencySign').CONFIGVAL();
});
/***********************************/

/***********************************/
MyApp_VM.ORDER_PREFIX = ko.computed(function () {
    return MyApp_VM.Get_StoreAdmin_ConfingItem('pOrderPrefix').CONFIGVAL();
});
/***********************************/

/***********************************/
MyApp_VM.COUNTRIES = ko.computed(function () {
    var arr_Countries = [];

    if (MyApp_VM.LOCATIONS() != null) {
        ko.utils.arrayForEach(MyApp_VM.LOCATIONS(), function (Location_Item) {
            if (Location_Item.LOCSTATE() == null || Location_Item.LOCSTATE() == '') {
                arr_Countries.push(Location_Item);
            }
        });
    }
    return arr_Countries.sort(function (left, right) {
        var a = left.LOCNAME();
        var b = right.LOCNAME();
        return a == b ? 0 : (a < b ? -1 : 1)
    });
});
/***********************************/

/***********************************/
MyApp_VM.REGIONS = ko.computed(function () {
    var arr_Regions = [];
    var js_Dest = MyApp_VM.Get_StoreAdmin_ConfingItem('fDestCode').CONFIGVAL();

    if (MyApp_VM.LOCATIONS() != null) {
        ko.utils.arrayForEach(MyApp_VM.LOCATIONS(), function (Location_Item) {
            if (Location_Item.LOCSTATE() != null && Location_Item.LOCSTATE() != '') {
                var Loc_Item = ko.mapping.toJS(Location_Item);
                
                var ShipmentTotal = 0;
                // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                
                var match_Shiprates = ko.utils.arrayFirst(MyApp_VM.SHIPRATES(), function (Shiprate_Item) {
                    return Shiprate_Item.LOCSHIPZONE() == Location_Item.LOCSHIPZONE();
                });
                if (match_Shiprates) {
                    // SHIPMENTTOTAL //
                    ShipmentTotal = match_Shiprates.ADDAMT();
                }                
                // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

                Loc_Item.LOCNAME = Loc_Item.LOCNAME + ' (' + js_Dest + ') - ' + MyApp_VM.CURRENCY_SIGN() + ShipmentTotal;
                arr_Regions.push(ko.mapping.fromJS(Loc_Item));
            }
        });
    }
    return arr_Regions.sort(function (left, right) {
        var a = left.LOCNAME();
        var b = right.LOCNAME();
        return a == b ? 0 : (a < b ? -1 : 1)
    });
});
/***********************************/

/***********************************/
MyApp_VM.CART_HEADER = ko.computed(function () {
    var js_return = "My Cart";
    if (MyApp_VM.CARTROWS() != null) {
        if (MyApp_VM.CARTROWS().length == 1) {
            js_return += " - 1 item";
        }
        else {
            js_return += " - " + MyApp_VM.CARTROWS().length + " items";
        }
    }
    return js_return;
});
/***********************************/

/***********************************/
MyApp_VM.CATEGORY_HEADER = ko.computed(function () {
    var js_Return = "";
    if (MyApp_VM.SELECTED_CATEGORY() != null) {
        js_Return = MyApp_VM.SELECTED_CATEGORY().CATEGORYDESC();
    }

    if (MyApp_VM.SELECTED_OCCASION() != null) {
        js_Return = MyApp_VM.SELECTED_OCCASION().CATEGORYDESC();
    }

    if (MyApp_VM.SELECTED_PRICE_BRACKET() != null) {
        js_Return = MyApp_VM.SELECTED_PRICE_BRACKET().CODE_VALUE_EN();
    }
    
    if (MyApp_VM.FILTER() != '') {
        js_Return = MyApp_VM.FILTER();
    }

    return js_Return;
});
/***********************************/
/*************************************************************************************************************************/
// END COMPUTED //

// Document Ready //
/*****************************************************/
$(document).ready(function () {
    // Explicitly call onDeviceReady() in case of web and not mobile.    
    if (window.mobilecheck()) {
        document.addEventListener("deviceready", onDeviceReady_With_Right_Version, false);
    }
    else {
        onDeviceReady();    //this is the browser
    }

    // #####################################################
    function onDeviceReady_With_Right_Version() {
        Assure_Latest_App_Version(onDeviceReady, null);
    }
    // #####################################################

    // #####################################################
    function onDeviceReady() {
        try {
            // ---------------            
            jq_ShowMobileLoader();
            jq_BlockUI();
            // ---------------

            // ---------------
            var MyPreEvent = function () {
                Notify("Pre");
            }
            var MyOfflineEvent = function () {
                _Is_Offline_Mode = true;
                Notify("You are working in offline mode");
            }

            var MyPreEventLocalDB = function () {
                Notify("MyPreEventLocalDB event fired");
            };

            var MyPostEventLocalDB = function () {

                // ------------------------
                Notify("MyPostEventLocalDB event fired");
                // ------------------------

                // ---------------
                //jq_HideMobileLoader();
                //jq_UnBlockUI();
                // ---------------

                // Hide the splash screen
                // ------------------------
                try {
                    navigator.splashscreen.hide();
                }
                catch (e) {
                    Notify("navigator.splashscreen.hide has thrown an error");
                }
                // ------------------------

                // Get available sources
                // ------------------------
                var Params_Get_Local_Source_By_OWNER_ID = new Object();
                Params_Get_Local_Source_By_OWNER_ID.OWNER_ID = parseInt(1);
                var Get_Local_Source_By_OWNER_ID_Success = function (result) {

                    // --------------- 
                    var _LIST_SOURCE = ko.mapping.fromJS([]);
                    if (result != null) {
                        for (var i = 0; i < result.length; i++) {
                            if (result[i].IS_ACTIVE == true || result[i].IS_ACTIVE == 'True') {
                                var Source_match = ko.utils.arrayFirst(_LIST_SOURCE(), function (Source_Item) {
                                    return result[i].CODE == Source_Item.CODE();
                                });
                                if (Source_match == null) {
                                    _LIST_SOURCE.push(ko.mapping.fromJS(result[i]));
                                }
                            }
                        }
                    }
                    // --------------- 

                    // ---------------                
                    MyApp_VM.LIST_SOURCE(_LIST_SOURCE().sort(function (left, right) {
                        var a = left.DESCRIPTION();
                        var b = right.DESCRIPTION();
                        return a == b ? 0 : (a < b ? -1 : 1)
                    }));
                    // ---------------                                                                                      
                };

                var Get_Local_Source_By_OWNER_ID_Failure = function () {

                    // ---------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------

                    // Hide the splash screen
                    // ------------------------
                    try {
                        navigator.splashscreen.hide();
                    }
                    catch (e) {
                        Notify("navigator.splashscreen.hide has thrown an error");
                    }
                    // ------------------------
                }


                // ---------------                
                Get_Local_Source_By_OWNER_ID
                (
                    Params_Get_Local_Source_By_OWNER_ID,
                    Get_Local_Source_By_OWNER_ID_Success,
                    Get_Local_Source_By_OWNER_ID_Failure
                );
                // ------------------------    
            };

            var MyPreEventRemoteDB = function () {

                // ------------------------
                Notify("MyPreEventRemoteDB event fired");
                // ------------------------

                // ---------------
                //jq_HideMobileLoader();
                //jq_UnBlockUI();
                // ---------------

                // Hide the splash screen
                // ------------------------
                try {
                    navigator.splashscreen.hide();
                }
                catch (e) {
                    Notify("navigator.splashscreen.hide has thrown an error");
                }
                // ------------------------

                // Get available sources
                // ------------------------               
                var Params_Get_Local_Source_By_OWNER_ID = new Object();
                Params_Get_Local_Source_By_OWNER_ID.OWNER_ID = parseInt(1);
                var Get_Local_Source_By_OWNER_ID_Success = function (result) {
                    // --------------- 
                    var _LIST_SOURCE = ko.mapping.fromJS([]);
                    if (result != null) {
                        for (var i = 0; i < result.length; i++) {
                            if (result[i].IS_ACTIVE == true || result[i].IS_ACTIVE == 'True') {
                                var Source_match = ko.utils.arrayFirst(_LIST_SOURCE(), function (Source_Item) {
                                    return result[i].CODE == Source_Item.CODE();
                                });
                                if (Source_match == null) {
                                    _LIST_SOURCE.push(ko.mapping.fromJS(result[i]));
                                }
                            }
                        }
                    }
                    // --------------- 

                    // ---------------                
                    MyApp_VM.LIST_SOURCE(_LIST_SOURCE().sort(function (left, right) {
                        var a = left.DESCRIPTION();
                        var b = right.DESCRIPTION();
                        return a == b ? 0 : (a < b ? -1 : 1)
                    }));
                    // ---------------

                    // Pre Select Source if exist in Device Data
                    // --------------------------------------                
                    var Get_Device_Data_By_Key_Success = function (result) {
                        var js_Return;

                        if (result.length == 0) {
                            //---------
                            js_Return = null;
                            //---------                        
                        }
                        else {
                            //---------
                            js_Return = result[0].DATA_VALUE;
                            //---------                                                
                        }

                        if (js_Return != null) {
                            var match = ko.utils.arrayFirst(MyApp_VM.LIST_SOURCE(), function (Item_Source) {
                                return parseInt(Item_Source.SURROGATE_ID()) == parseInt(js_Return);
                            });

                            if (match) {
                                MyApp_VM.SELECTED_SOURCE(match);
                                try { $("#ddl_index_source").val(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID()).selectmenu('refresh'); /*$("#ddl_index_source").selectmenu('refresh');*/ } catch (e) { }
                            }
                        }


                    };

                    Get_Device_Data_By_Key("SOURCE_ID", Get_Device_Data_By_Key_Success);
                    // --------------------------------------                                                    
                };

                var Get_Local_Source_By_OWNER_ID_Failure = function () {

                }


                // ---------------                    
                Get_Local_Source_By_OWNER_ID
                (
                    Params_Get_Local_Source_By_OWNER_ID,
                    Get_Local_Source_By_OWNER_ID_Success,
                    Get_Local_Source_By_OWNER_ID_Failure
                );
                // ------------------------                                           
            };

            var MyPostEventRemoteDB = function () {

                // ---------------
                Notify("MyPostEventRemoteDB event fired");
                // ---------------

                // ---------------
                jq_HideMobileLoader();
                jq_UnBlockUI();
                // ---------------

                // Hide the splash screen
                // ------------------------
                try {
                    navigator.splashscreen.hide();
                }
                catch (e) {
                    Notify("navigator.splashscreen.hide has thrown an error");
                }
                // ------------------------

                // Log Sync time
                // ---------------
                Edit_Device_Data("LAST_SYNC_TIME", new Date().getTime());
                // ---------------

                // Get available sources Sources
                // ------------------------
                var Params_Get_Local_Source_By_OWNER_ID = new Object();
                Params_Get_Local_Source_By_OWNER_ID.OWNER_ID = parseInt(1);
                var Get_Local_Source_By_OWNER_ID_Success = function (result) {

                    // --------------- 
                    var _LIST_SOURCE = ko.mapping.fromJS([]);
                    if (result != null) {
                        for (var i = 0; i < result.length; i++) {
                            if (result[i].IS_ACTIVE == true || result[i].IS_ACTIVE == 'True') {
                                var Source_match = ko.utils.arrayFirst(_LIST_SOURCE(), function (Source_Item) {
                                    return result[i].CODE == Source_Item.CODE();
                                });
                                if (Source_match == null) {
                                    _LIST_SOURCE.push(ko.mapping.fromJS(result[i]));
                                }
                            }
                        }
                    }
                    // --------------- 

                    // ---------------                
                    MyApp_VM.LIST_SOURCE(_LIST_SOURCE().sort(function (left, right) {
                        var a = left.DESCRIPTION();
                        var b = right.DESCRIPTION();
                        return a == b ? 0 : (a < b ? -1 : 1)
                    }));
                    // ---------------

                    // Pre Select Source if exist in Device Data
                    // --------------------------------------                
                    var Get_Device_Data_By_Key_Success = function (result) {
                        var js_Return;

                        if (result.length == 0) {
                            //---------
                            js_Return = null;
                            //---------                        
                        }
                        else {
                            //---------
                            js_Return = result[0].DATA_VALUE;
                            //---------                                                
                        }

                        if (js_Return != null) {
                            var match = ko.utils.arrayFirst(MyApp_VM.LIST_SOURCE(), function (Item_Source) {
                                return parseInt(Item_Source.SURROGATE_ID()) == parseInt(js_Return);
                            });

                            if (match) {
                                MyApp_VM.SELECTED_SOURCE(match);
                                try { $("#ddl_index_source").val(MyApp_VM.SELECTED_SOURCE().SURROGATE_ID()).selectmenu('refresh'); /*$("#ddl_index_source").selectmenu('refresh');*/ } catch (e) { }
                            }
                        }
                    };
                    Get_Device_Data_By_Key("SOURCE_ID", Get_Device_Data_By_Key_Success);
                    // --------------------------------------                                
                };

                var Get_Local_Source_By_OWNER_ID_Failure = function () {

                    // ---------------
                    jq_HideMobileLoader();
                    jq_UnBlockUI();
                    // ---------------

                    // Hide the splash screen
                    // ------------------------
                    try {
                        navigator.splashscreen.hide();
                    }
                    catch (e) {
                        Notify("navigator.splashscreen.hide has thrown an error");
                    }
                    // ------------------------
                }


                // ---------------                
                Get_Local_Source_By_OWNER_ID
                (
                    Params_Get_Local_Source_By_OWNER_ID,
                    Get_Local_Source_By_OWNER_ID_Success,
                    Get_Local_Source_By_OWNER_ID_Failure
                );
                // ------------------------


                // Get no image DATA_URI
                // ------------------------
                var Params_Get_Local_Setup_No_Image = new Object();
                Params_Get_Local_Setup_No_Image.OWNER_ID = 1;
                Params_Get_Local_Setup_No_Image.TBL_NAME = '_SYSMTE';
                Params_Get_Local_Setup_No_Image.CODE_NAME = 'NO_IMAGE';

                var Get_Local_Setup_No_Image_Success = function (result) {

                    // --------------
                    Notify("Get_Local_Setup_No_Image_Success: " + result.length);
                    // --------------

                    // --------------
                    if (result.length > 0) {
                        js_No_Image_Data_URI = result[0].CODE_VALUE_EN;
                    }
                    // --------------
                }

                var Get_Local_Setup_No_Image_Failure = function () {
                    Notify("Get_Local_Setup_No_Image_Failure");
                }

                Get_Local_Setup_By_OWNER_ID_TBL_NAME_CODE_NAME
                (
                  Params_Get_Local_Setup_No_Image,
                  Get_Local_Setup_No_Image_Success,
                  Get_Local_Setup_No_Image_Failure
                );
                // ------------------------

                // Assure_Device_Registration_Success
                // ------------------------
                var Assure_Device_Registration_Success = function (i_DEVICE_ID) {

                    // PNS Registration
                    // ------------
                    var Assure_PNS_Token_Registration_Success = function (i_Token) {
                        Notify("Token: " + i_Token);
                    }

                    Assure_PNS_Token_Registration
                        (
                            i_DEVICE_ID,
                            Assure_PNS_Token_Registration_Success,
                            null
                        );
                    // ------------                                       

                    //try {
                    // Contacts Collection
                    // ------------
                    /*var Collect_Contacts_Success = function () { };
                    var js_platform = device.platform;
                    if (js_platform == 'android' || js_platform == 'Android') {
                    Collect_Contacts
                    (
                    i_DEVICE_ID,
                    Collect_Contacts_Success,
                    null
                    );
                    }
                    }
                    catch (e) { Notify(e.message); }*/
                    // ------------                    
                };
                // ------------------------

                // Assure_Device_Registration_Failure
                // ------------------------
                var Assure_Device_Registration_Failure = function () { Notify("Error while calling Assure_Device_Registration"); };
                // ------------------------

                // Assure_Device_Registration
                // ------------------------
                if (_Is_Offline_Mode == false) {
                    Assure_Device_Registration
						(
							Assure_Device_Registration_Success,
							Assure_Device_Registration_Failure
						);
                }
                // ------------------------                                       
            };
            // ---------------

            // ---------------
            var My_Extra_LocalDB_Params = [];
            //var Extra_LocalDB_Param = new Object();
            //Extra_LocalDB_Param.PARAM_NAME = "APPLICATION_ID";
            //Extra_LocalDB_Param.PARAM_VALUE = _APPLICATION_ID;
            //My_Extra_LocalDB_Params.push(Extra_LocalDB_Param);
            //_Exclusive_Tables_To_Sync = [];
            //_Exclusive_Tables_To_Sync.push("[TBL_SOURCE]");
            DB_Initializer(MyPreEvent, MyPreEventLocalDB, MyPostEventLocalDB, MyPreEventRemoteDB, MyPostEventRemoteDB, MyOfflineEvent, My_Extra_LocalDB_Params);
            // ---------------

            // Detect for network access
            // -------------------------
            jq_networkDetection();
            // attach events for online and offline detection
            document.addEventListener("online", onOnline, false);
            document.addEventListener("offline", onOffline, false);
            // -------------------------

            // On Resume event when phone is in background and comes to foreground we trigger SYNC
            // -------------------------
            document.addEventListener("resume", onResume, false);

            // Handle the resume event
            function onResume() {
                // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                var Get_Device_Data_By_Key_Success = function (result) {
                    if (result.length > 0) {
                        var lastSyncTime = parseInt(result[result.length - 1].DATA_VALUE);
                        var current_time = new Date().getTime();
                        var time_diff = js_timeDiff(lastSyncTime, current_time, 'H');

                        if (time_diff >= js_Sync_Interval_Time) {
                            var currentPageId = $(":mobile-pagecontainer").pagecontainer("getActivePage")[0].id;
                            var arr_ExcludedPages = ['pg_index'];
                            // #############################################
                            if ($.inArray(currentPageId, arr_ExcludedPages) == -1) {
                                // Sync Data with Server
                                // ---------------
                                // ---------------------
                                jq_ShowMobileLoader();
                                jq_BlockUI();
                                // ---------------------
                                var Func_PostEventRemoteDB = function () {
                                    // Log Sync time
                                    // ---------------                                    
                                    Edit_Device_Data("LAST_SYNC_TIME", new Date().getTime());
                                    // ---------------

                                    // ---------------------
                                    Get_Synced_Data(MyApp_VM.SELECTED_SOURCE());
                                    // ---------------------

                                    if (MyApp_VM.SEARCHED_PRODUCTS().length > 0 && currentPageId == 'pg_listing') {
                                        jq_NavigateToPage('pg_home');
                                        $("#Txt_Filter").trigger("change");
                                    }
                                    // ---------------------

                                    // ---------------------
                                    jq_HideMobileLoader();
                                    jq_UnBlockUI();
                                    // ---------------------
                                };
                                DB_Initializer(MyPreEvent, MyPreEventLocalDB, MyPostEventLocalDB, MyPreEventRemoteDB, Func_PostEventRemoteDB, MyOfflineEvent, My_Extra_LocalDB_Params);
                                // ---------------
                            }
                            // #############################################                                
                        }
                    }
                };
                Get_Device_Data_By_Key("LAST_SYNC_TIME", Get_Device_Data_By_Key_Success);
                // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
            }
            // -------------------------

            // Check if platform = iOS & Version >= 7.0 to apply top margin //
            // Check if platform = Win32NT(wp8) to Hide Status Bar //
            // -------------------------
            try {
                // Set Global PLATFORM 
                // ---------------------
                MyApp_VM.PLATFORM(window.device.platform);
                // ---------------------
                if (window.device.platform == "iOS" && parseFloat(window.device.version) >= 7.0) {
                    //document.body.style.marginTop = "20px";
                    //$("body").addClass("ios7");
                    //$('body').prepend('<div id="ios7statusbar"/>');
                    StatusBar.overlaysWebView(false);
                    StatusBar.show();
                }
                else if (window.device.platform == "Win32NT") {
                    StatusBar.hide();
                }
            }
            catch (e) { Notify(e.message); }
            // -------------------------
        }
        catch (e) { Notify('Deviceready: ' + e.message); }
    }
    // #####################################################

    // Carousel stuff //
    /***********************************/
    carouselOptions = {
        itemsMobile: [360, 2],
        itemsTabletSmall: [630, 3],
        itemsTablet: [768, 4],
        itemsDesktopSmall: [979, 5],
        itemsDesktop: [1199, 6],
        itemsDesktopLarge: [1224, 7],
        itemsDesktopXLarge: [1824, 8],
        /*itemsMobile: [479, 2],
        itemsTablet: [768, 3],
        itemsDesktop: [1199, 5],*/
        pagination: false,
        navigation: true,
        navigationText: ["<img src='images/arrow-l.png' style='vertical-align:middle' />&nbsp;", "&nbsp;<img src='images/arrow-r.png' style='vertical-align:middle' />"]//["◄&nbsp;", "&nbsp;►"]  //["&#9668;&nbsp;", "&nbsp;&#9658;"]
    };
    carouselElem = $('#carousel_featured_products');
    carousel = carouselElem.owlCarousel(carouselOptions);
    /***********************************/

    // Change defaults //
    /***********************************/
    // EXTERNAL TOOLBARS //
    ////////////////////////////////////////////////////////////////
    //$("div[data-role='header']").toolbar({ theme: "a" });    
    $("div[data-role='footer'].common-footer").toolbar({ theme: "d" });
    $("div[data-role='popup']").enhanceWithin().popup();
    $("div[data-role='panel']").enhanceWithin().panel();
    ////////////////////////////////////////////////////////////////    
    /***********************************/

    // Fix the footer position to not float in the middle
    /***********************************/
    //stick the footer at the bottom of the page if we're on an iPad/iPhone due to viewport/page bugs in mobile webkit 
    /*if (navigator.platform == 'iPad' || navigator.platform == 'iPhone' || navigator.platform == 'iPod') {
    $("div[data-role='footer'].common-footer").css("position", "static");
    };*/
    /***********************************/

    // FastClick Init //
    /***********************************/
    FastClick.attach(document.body);
    /***********************************/

    // Knockout Binding //
    /***********************************/
    ko.applyBindings(MyApp_VM);
    /***********************************/

    // Global events for App //
    /***********************************/
    //// ORIENTATION CHANGE ////    
    /////////////////////////////////////////////////////////////////////////
    $(window).on("orientationchange", function (event) {
        $.mobile.resetActivePageHeight();
    });
    /////////////////////////////////////////////////////////////////////////    

    //// CAROUSEL DIV CLICK EVENT ////
    /////////////////////////////////////////////////////////////////////////
    $(document).on("click", ".featured_product", function (e) {
        var prodid = $(this).data("prodid");
        var match = ko.utils.arrayFirst(MyApp_VM.FEATURED_PRODUCTS(), function (featured_product) {
            return featured_product.IDPRODUCT().toString() == prodid.toString();
        });
        if (match) {
            MyApp_VM.SELECTED_CATEGORY(null);
            MyApp_VM.SELECTED_OCCASION(null);
            MyApp_VM.SELECTED_PRICE_BRACKET(null);

            MyApp_VM.SHOW_PRODUCT_DETAILS(match);
        }
        e.preventDefault();
    });
    /////////////////////////////////////////////////////////////////////////

    //// NAVBAR ////
    /////////////////////////////////////////////////////////////////////////
    $(document).on("click", ".nav-home, #Btn_home, #Btn_ContinueShopping", function (e) {
        jq_NavigateToPage("pg_home");
        e.preventDefault();
    });
    $(document).on("click", ".nav-cart, #Btn_Cart", function (e) {//#Btn_Add_To_Cart
        jq_NavigateToPage("pg_cart");
        e.preventDefault();
    });
    $(document).on("click", ".nav-myacct, .Lnk_MyAcc", function (e) {
        // ---------------------
        MyApp_VM.LOGIN_PURPOSE("MYACC");    // My Account
        // ---------------------

        // ---------------------
        if (MyApp_VM.IS_LOGGEDIN()) {
            // Connection Check //
            // -------------------------            
            if (!jq_ConnectionExist()) {
                return;
            }
            // -------------------------

            jq_NavigateToPage("pg_myaccount");
        }
        else {
            jq_NavigateToPage("pg_login");
        }
        // ---------------------

        e.preventDefault();
    });
    $(document).on("click", ".nav-call", function (e) {
        window.location = 'tel:' + MyApp_VM.Get_StoreAdmin_ConfingItem('fPhone').CONFIGVAL();
        e.preventDefault();
    });
    /////////////////////////////////////////////////////////////////////////    

    //// RIGHT PANEL LINKS ////
    /////////////////////////////////////////////////////////////////////////
    $(document).on("click", ".Lnk_AboutUs", function (e) {
        jq_NavigateToPage("pg_aboutus");
        e.preventDefault();
    });
    $(document).on("click", ".Lnk_ContactUs", function (e) {
        jq_NavigateToPage("pg_contactus");
        e.preventDefault();
    });
    $(document).on("click", ".Lnk_PrivacyPolicy", function (e) {
        jq_NavigateToPage("pg_privacypolicy");
        e.preventDefault();
    });
    $(document).on("click", ".Lnk_SalesCond", function (e) {
        jq_NavigateToPage("pg_salescond");
        e.preventDefault();
    });
    /////////////////////////////////////////////////////////////////////////

    //// NAVIGATION LINKS ////
    /////////////////////////////////////////////////////////////////////////    
    $(document).on("click", ".Lnk_Logout", function (e) {
        // ------------------
        obj_Customer = null;
        ko.mapping.fromJS(Customer, _Customer);
        MyApp_VM.IS_LOGGEDIN(false);
        // ------------------
        jq_NavigateToPage("pg_login");

        e.preventDefault();
    });
    $(document).on("click", ".Lnk_CustOrder", function (e) {
        // ---------------------
        jq_NavigateToPage("pg_custorder");
        // ---------------------

        e.preventDefault();
    });
    $(document).on("click", ".Lnk_Profile", function (e) {
        // ---------------------
        MyApp_VM.LOGIN_PURPOSE("MYACC");    // My Account
        // ---------------------
        // ---------------------
        jq_NavigateToPage("pg_customer");
        // ---------------------

        e.preventDefault();
    });
    /////////////////////////////////////////////////////////////////////////
});
/*****************************************************/

// "pagecontainercreate" centralized event for all pages in the App //
/*****************************************************/
$(document).on("pagecontainercreate", function (event, ui) {
    $(".ActionTheme").attr("data-theme", "e");
});
/*****************************************************/

// "pagecontainerbeforeshow" centralized event for all pages in the App //
/*****************************************************/
$(document).on("pagecontainerbeforeshow", function (event, ui) {
    // No Disc Icon //
    $("div.ui-btn, a.ui-btn").addClass("ui-nodisc-icon");
});
/*****************************************************/

// "pagecontainerbeforetransition" centralized event for all pages in the App //
/*****************************************************/
$(document).on("pagecontainerbeforetransition", function (event, ui) {
    var pg_id = ui.toPage[0].id;

    var page = $("#" + pg_id);
    page.css("-webkit-backface-visibility", "hidden");
    //$.mobile.changePage("#somepage", {transition: "slide"});
    setTimeout(function () { page.css("-webkit-backface-visibility", "visible"); }, 450);

    // Insert common header & footer //
    /*******************************************************************/
    var arr_ExcludedPages = ['pg_index'];
    if ($.inArray(pg_id, arr_ExcludedPages) == -1) {
        //$('.common-header:first').show();
        $('.common-footer:first').toolbar({ fullscreen: false });
        $('.common-footer:first').show();
    }
    else {
        //$('.common-header:first').hide();
        $('.common-footer:first').toolbar({ fullscreen: true });
        $('.common-footer:first').hide();
    }
    $.mobile.resetActivePageHeight();
    //$.mobile.activePage.trigger('updatelayout');
    /*******************************************************************/
});
/*****************************************************/